# coding: utf-8

"""
    fission

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: v1.30.5
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from fission_client.models.io_fission_v1_time_trigger_spec_functionref import IoFissionV1TimeTriggerSpecFunctionref
from typing import Optional, Set
from typing_extensions import Self

class IoFissionV1TimeTriggerSpec(BaseModel):
    """
    TimeTriggerSpec invokes the specific function at a time or times specified by a cron string.
    """ # noqa: E501
    cron: StrictStr = Field(description="Cron schedule")
    functionref: IoFissionV1TimeTriggerSpecFunctionref
    method: Optional[StrictStr] = Field(default=None, description="HTTP Method for trigger, ex : GET, POST, PUT, DELETE, HEAD (default: \"POST\")")
    subpath: Optional[StrictStr] = Field(default=None, description="Subpath to trigger a specific route if function internally supports routing, (default: \"/\")")
    __properties: ClassVar[List[str]] = ["cron", "functionref", "method", "subpath"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of IoFissionV1TimeTriggerSpec from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of functionref
        if self.functionref:
            _dict['functionref'] = self.functionref.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of IoFissionV1TimeTriggerSpec from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "cron": obj.get("cron"),
            "functionref": IoFissionV1TimeTriggerSpecFunctionref.from_dict(obj["functionref"]) if obj.get("functionref") is not None else None,
            "method": obj.get("method"),
            "subpath": obj.get("subpath")
        })
        return _obj


